'===============================================================================
'
' 4     ATMega48.
'
' (c)  .  2007 ., atlab@narod.ru
'
'    !
'      (  )  
'     !
'
' : 26  2007 .
' : 19  2007 .
'
'     http://atlab.narod.ru/articles/particle10.htm
' 22  2007 .
'===============================================================================
'
' :
' -   8 
' - 4      
' -    ,    
' - 0  < U. < 12 
' - 3  
' - 2*16 LCD ,   , /.,
'   %  .    
' - 10 .       
'===============================================================================
'
' :
'   -  -   
'   -  -    
'   -  -   () 
'   - + -   ( )
'
' LCD    :
' Db4 - Portc.0
' Db5 - Portc.1
' Db6 - Portc.2
' Db7 - Portc.3
' E   - Portc.4
' Rs  - Port.5
'
'  :
' 5  - OC2B/PD3  - Pwm4
' 11 - OC0B/PD5  - Pwm2
' 12 - OC0A/PD6  - Pwm1
' 17 - OC2A/PB3  - Pwm3
'
'  :
' -  ->   
' -   -> 
'
'===============================================================================

 $regfile = "m48def.dat"
 $crystal = 8000000

'-   ------------------------------------------------------
'Config Timer0 = Pwm , Prescale = 1 , Compare A Pwm = Clear Down , Compare B Pwm = Clear Down ' <-   Bascom-AVR!!!!!
'    ,    ,  -    
 Tccr0a = &HF3
 Tccr0b = &H01
'Config Timer2 = Pwm , Prescale = 1 , Compare A Pwm = Clear Up , Compare B Pwm = Clear Up  ' <-   Bascom-AVR!!!!!
'        ,  -    
 Tccr2a = &HF3
 Tccr2b = &H01
Config Timer1 = Timer , Prescale = 64                       '  SysClock,    TOV1
 '-------------------------------------------------------------------------------

'-   --------------------------------------------------------
Config Portb = &B11001001                                   'PB1,2,4,5 ,  - 
Portb = &B00110110                                          '   
Config Portc = &B10111111                                   'P6 - 
Portc = &B01000000                                          '   ,   -  
Config Portd = &B11101000                                   'PD0,1,2,4 - 
Portd = &B00010111                                          '   ,   -  
'-------------------------------------------------------------------------------

'-   LCD ------------------------------------------------
Config Lcdpin = Pin , Db4 = Portc.0 , Db5 = Portc.1 , Db6 = Portc.2 , Db7 = Portc.3 , E = Portc.5 , Rs = Portc.4
Config Lcd = 16 * 2
'-------------------------------------------------------------------------------

'-   ----------------------------------------------------------
Key1 Alias Pind.0                                           ' 
Key2 Alias Pind.1                                           ' 
Key3 Alias Pind.2                                           ' 
'-------------------------------------------------------------------------------

'-   -----------------------------------------------------
Speaker Alias Portd.4                                       '
'-------------------------------------------------------------------------------

'-  ------------------------------------------------------------------
Dim T1over As Bit                                           '  Timer1  -  
Dim Needshow As Bit                                         '  -    
Dim Needtosave As Bit                                       '  -     EEPROM
Dim Fixnchan As Bit                                         '    

Dim Key1pressed As Byte
Dim Key2pressed As Bit                                      '
Dim Key3pressed As Byte

Dim Cntr As Byte                                            ' 
Dim Ptr As Byte                                             ' 
Dim Q(4) As Byte                                            '    
Dim Nchan As Byte                                           '   
Dim Nc As Byte
Dim Pcintcntr As Byte                                       '   PCINT    

Dim Perc As Word                                            '
Dim I As Byte                                               '
Dim J As Byte                                               '
Dim K As Byte                                               '

Dim Pixelprogress As Word
Dim T1 As Word                                              '   TMR1   
Dim Nmax(4) As Word                                         '
Dim N(4) As Word                                            '
Dim Nl As Long                                              '    /
Dim Buf As Word
Dim W As Word

Dim Nchstr As String * 1

$eeprom
Data 32 , 64 , 128 , 196
$data
'-------------------------------------------------------------------------------

'-   --------------------------------------------------------
 On Pcint0 Isr_pcint0                                       '      PCINT0-7 (PortB)
                                                            '     
 On Ovf1 Isr_tmr1                                           '    Tmr1
'-------------------------------------------------------------------------------

'-   ------------------------------------------------------------
Progstart:                                                  '    

 Pcmsk0 = 0                                                 '   
 Timsk = 1                                                  '      TMR1
 Disable Pcint0
 Stop Timer1
 Disable Timer1

 Pwm0a = 255
 Pwm0b = 255
 Pwm2a = 255
 Pwm2b = 255

'      Progressbar
 Deflcdchar 0 , 32 , 32 , 32 , 32 , 32 , 32 , 32 , 32       '
 Deflcdchar 1 , 16 , 16 , 16 , 16 , 16 , 16 , 16 , 16       '
 Deflcdchar 2 , 24 , 24 , 24 , 24 , 24 , 24 , 24 , 24       '
 Deflcdchar 3 , 28 , 28 , 28 , 28 , 28 , 28 , 28 , 28       '
 Deflcdchar 4 , 30 , 30 , 30 , 30 , 30 , 30 , 30 , 30       '
 Deflcdchar 5 , 31 , 31 , 31 , 31 , 31 , 31 , 31 , 31       '
'  " "
 Deflcdchar 6 , 16 , 24 , 28 , 30 , 30 , 28 , 24 , 16       '>

 Cls
 Cursor Off Noblink

 Upperline
 Lcd " Rheobus v2.00L"
 Lowerline
 Lcd " (c) 2007 ATLab"

 Waitms 10000                                               ' 10    

 Needshow = 0

 Enable Interrupts

 For Nchan = 1 To 4 Step 1                                  '    
   Ptr = Nchan + 8
   Readeeprom Q(nchan) , Ptr
   Gosub Speedmeter                                         '    
   Waitms 500
   If Needshow = 1 Then
     Gosub Calcspeed
     Nmax(nchan) = Nl                                       ' 7500000 \ T1
     Needshow = 0
   Else
     Nmax(nchan) = 0
   End If
 Next Nchan

 Pwm0b = Q(1)
 Pwm0a = Q(2)
 Pwm2a = Q(3)
 Pwm2b = Q(4)

 Waitms 2000                                                ' 2     

 Nchan = 4                                                  '    1 
 Cntr = 3                                                   '    
 T1over = 0                                                 '  
 Needshow = 0                                               '  
 Needtosave = 0
 Fixnchan = 0

 Key1pressed = 0
 Key2pressed = 0
 Key3pressed = 0

'-       -------------------------------
 Do
'    1,3
   If Key1 = 0 Or Key3 = 0 Then

'     
     If Key1 = 0 And Key3 = 0 Then
       Goto Progstart                                       '   
     End If

'    3 - ,  
     If Key3 = 0 Then                                       '   
       If Key3pressed < 5 Then                              '  ,     
         Key3pressed = Key3pressed + 1                      '  1        
       End If

       If Key3pressed = 1 Or Key3pressed => 5 Then          '     
         If Q(nchan) => 254 Then
           Q(nchan) = 255
         Else
           Q(nchan) = Q(nchan) + 2
         End If
       End If
     Else
       Key3pressed = 0                                      '      
     End If

'    1 - ,  
     If Key1 = 0 Then                                       '   
       If Key1pressed < 5 Then                              '  ,     
         Key1pressed = Key1pressed + 1                      '  1        
       End If

       If Key1pressed = 1 Or Key1pressed => 5 Then          '     
         If Q(nchan) <= 2 Then
           Q(nchan) = 0
         Else
           Q(nchan) = Q(nchan) - 2
         End If
       End If
     Else
       Key1pressed = 0
     End If

'       
     Pwm0b = Q(1)
     Pwm0a = Q(2)
     Pwm2a = Q(3)
     Pwm2b = Q(4)

     Cntr = 0
     Needtosave = 1

'       
     If Q(nchan) = 0 Then
       Gosub Showfan
     Else
       Gosub Speedmeter                                     '     
     End If

   Else
     Key1pressed = 0
     Key3pressed = 0
   End If

'    2
   If Key2 = 0 Then                                         '    
     If Key2pressed = 0 Then
       Key2pressed = 1
       Locate 1 , 1
       If Fixnchan = 0 Then
         Fixnchan = 1
         Lcd Chr(6)                                         ' >
       Else
         Fixnchan = 0
         Lcd " "
       End If
     End If
   Else
     Key2pressed = 0
   End If

' 
   Waitms 250
   Cntr = Cntr + 1

'  0,5 .         EEPROM
   If Needtosave = 1 Then
     If Cntr => 2 Then
       Writeeeprom Q(1) , 9
       Writeeeprom Q(2) , 10
       Writeeeprom Q(3) , 11
       Writeeeprom Q(4) , 12
       Needtosave = 0                                       '  
     End If
   End If

'  2    
   If Cntr => 8 Then                                        '      
     Cntr = 0
     If Fixnchan = 0 Then
       Nchan = Nchan + 1                                    '     
       If Nchan > 4 Then                                    '  .  
         Nchan = 1                                          '   . ()
       End If
     End If

     If Q(nchan) = 0 Then
       Gosub Showfan
     Else
       Gosub Speedmeter                                     '     
     End If
   End If

   '   ,       
   If Needshow = 1 Then
     Gosub Calcspeed                                        '  
     N(nchan) = Nl                                          '7500000 \ T1                                '60000000 \ T1
     If N(nchan) > Nmax(nchan) Then
        Nmax(nchan) = N(nchan)
     End If
     Gosub Showfan                                          '   LCD
     Needshow = 0
   End If

'   ,  ,      , 
   If T1over = 1 Then
     Gosub Showfan                                          '   LCD
     T1over = 0
   End If

 Loop
'-------------------------------------------------------------------------------


'===============================================================================
'   
Showfan:
'-------------------------------------------------------------------------------
 Nc = Nchan + 48                                            '    ,   
 Nchstr = Chr(nc)                                           '           "Showfan"

 Cls
 Locate 1 , 1
 If Fixnchan = 1 Then
   Lcd Chr(6)                                               '"{201}"                                              ' >
 Else
   Lcd " "
 End If
 Locate 1 , 2
 Lcd "Ka{189}a{187}"                                        ' 
 Lcd Nchstr
 If Q(nchan) = 0 Then
   Lcd " {179}{195}{186}{187}{198}{192}e{189}"              ' 
 Else
   If T1over = 1 Then
     Lcd " ABAP{165}{177}! "                                ' !
     For I = 1 To Nchan                                     ' 
       For W = 600 To 300 Step -4
         Sound Speaker , 5 , W                              '
       Next J
       Waitms 200
     Next I
   Else
     Lcd " "
     Lcd Str(n(nchan))                                      ' - 
     Lcd " o{178}."                                         ' .
     Perc = N(nchan) * 10
     Pixelprogress = Perc
     Buf = Nmax(nchan) \ 10
     Perc = Perc \ Buf

     Locate 2 , 2                                           '  %
     Lcd Str(perc)
     Lcd "% "

     Buf = Nmax(nchan) \ 5
     Pixelprogress = Pixelprogress \ Buf                    ' Nmax(nchan)

     Locate 2 , 6                                           '  -
     For I = 0 To 9 Step 1
       J = I * 5
       K = J + 5
       If K > Pixelprogress Then
         If J > Pixelprogress Then
           Ptr = 0
         Else
           Ptr = Pixelprogress Mod 5
         End If
       Else
           Ptr = 5
       End If
      Lcd Chr(ptr)
     Next I
       End If
     End If

 Return
'===============================================================================

'===============================================================================
'  ,   my    
Calcspeed:
'-------------------------------------------------------------------------------
 Nl = 7500000 \ T1
 Return
'===============================================================================

'===============================================================================
'     
Speedmeter:
'-------------------------------------------------------------------------------
 If Q(nchan) = 0 Then                                       '   ,   
   Return
 End If

 Pcintcntr = 0
 Timer1 = 0
 T1 = 0

 Start Timer1

 Select Case Nchan                                          '
 Case 4
   Pcmsk0 = &B00100000                                      '   Tach4
 Case 3
   Pcmsk0 = &B00010000                                      '   Tach3
 Case 2
   Pcmsk0 = &B00000100                                      '   Tach2
 Case 1
   Pcmsk0 = &B00000010                                      '   Tach1
 End Select

 Waitus 5                                                   '     

 Pcifr = 0                                                  '   PCINT    
 Enable Pcint0
 Enable Ovf1

 Return
'===============================================================================

'===============================================================================
Isr_pcint0:
'-------------------------------------------------------------------------------
 If Pcintcntr = 0 Then
   Timer1 = 0                                               '    
 End If

 Pcintcntr = Pcintcntr + 1

 If Pcintcntr = 5 Then
   Stop Timer1                                              '   
   T1 = Timer1

   Pcmsk0 = 0                                               ' !!!! !!!    PCINT0
   Disable Pcint0                                           '    
   Disable Timer1                                           '  TMR1

   Needshow = 1
                                     '
 End If

 Return
'===============================================================================

'===============================================================================
Isr_tmr1:
'-------------------------------------------------------------------------------
 Stop Timer1
 Disable Timer1
 T1over = 1                                                 '  
 Return
'===============================================================================
 End